using System;
using System.Text;
using Server.Gumps;
using Server.Network;
using Server.Spells;

namespace Server.Items
{
	public class RoseofTrinsic: Item
	{

		private int m_UsesRemaining;
		private SpawnTimer m_Timer;

		[CommandProperty( AccessLevel.GameMaster )]
		public int UsesRemaining
		{
			get { return m_UsesRemaining; }
			set { m_UsesRemaining = value; InvalidateProperties(); }
		}

		[Constructable]
		public RoseofTrinsic() : base( 0x18E9 )
		{
			Weight = 1.0;
			LootType = LootType.Newbied;
			Name = "Rose of Trinsic";
			Hue = 0x15;
			m_Timer = new SpawnTimer( this );
			m_Timer.Start();
		}

		public RoseofTrinsic( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}

		public override void OnDoubleClick( Mobile from )
		{
			if (m_UsesRemaining >= 1)
			{
				SpellHelper.AddStatBonus( from , from , StatType.Str, 5, TimeSpan.FromMinutes( 5 ));
				m_UsesRemaining = m_UsesRemaining -1;
			}
		}

		public void SpawnPetal()
		{
			if (m_UsesRemaining <= 9)
			{
				m_UsesRemaining++;
			}					
		}

		public override void GetProperties( ObjectPropertyList list )
		{
			base.GetProperties( list );

			list.Add( 1060584, m_UsesRemaining.ToString() );
		}

		private class SpawnTimer : Timer
		{
			private RoseofTrinsic m_Item;

			public SpawnTimer( RoseofTrinsic item ) : base( TimeSpan.FromHours( 4 ) )
			{
				Priority = TimerPriority.FiftyMS;
				m_Item = item;
			}

			protected override void OnTick()
			{
				m_Item.SpawnPetal();
			}
		}

	}
}